/*
	IP AhX

	$Header$
*/

#define _IN_ADDR2_C_

#include <dos.h>		/* MK_FP */

#include <ttypes.h>

#include "inet.h"

/*******************************
	ϐ
*******************************/

/* ChJ[hAhX (IPADDR ^ƂĎQƂ) */
const BYTE ipaddr_any[sizeof(IPADDR)]=
			{IPADDR_IPV4,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

/* IPv4AhXev[g (IPADDR ^ƂĎQƂ) */
static const BYTE template_ipv4[sizeof(IPADDR)]=
			{IPADDR_IPV4,0, 0,0,0,0,0,0,0,0,0,0,0xff,0xff,0,0,0,0};


/*******************************
	R[h	ē\
*******************************/

/*
IPAhX\́AIPAhX IPv4 AhX(4oCg)ɕϊ
@óFchar			0..
				EINET_BADFORMAT ϊs(zXgł)
@⑫Faddr=NULL Ȃ 0.0.0.0 Ԃ
*/

char inet_toipv4addr(const void FAR *addr, IDWORD FAR *ipv4addr)
{
	if (addr==0) {
		*ipv4addr=0;
		return 0;
	}
	else if ( ((IPADDR FAR *)addr)->type == IPADDR_IPV4 ) {
/*		*ipv4addr = *((IDWORD *)(((IPADDR FAR *)addr)->addr));*/
		*ipv4addr = ((IPADDR FAR *)addr)->addr.ipv4.addr;
		return 0;
	}
	else {
		unsigned char FAR *astr=(unsigned char FAR *)addr;
		IDWORD _abin;
		BYTE *abin=(BYTE *) &_abin;
		uint a=0;
		int i=0;
		unsigned char c;

		for (;;) {
			c=*(astr++)-'0';
			if (c<=9) {
				/*  */
				if ( (a=a*10+c) > 255 ) return EINET_BADFORMAT;
			}
			else if (c==256+'.'-'0' || c==256+'\0'-'0') {
				/* . ܂ \0 */
				abin[i++]=a;
				a=0;
				if (c==256+'\0'-'0') {
					if (i==4) {
						*ipv4addr=_abin;
						return 0;
					}
					else return EINET_BADFORMAT;
				}
				else if (i>4) return EINET_BADFORMAT;
			}
			else {
				return EINET_BADFORMAT;
			}
		}
	}
}


/*
IPAhX(4oCg)IPAhX\̂𓾂
@⑫Fipv4addr=0 ̂Ƃ ipaddr_any ƓlԂB
*/

IPADDR FAR *inet_ipv4addrtoipaddr(IDWORD ipv4addr, IPADDR FAR *ipaddr)
{
#if 0
	*ipaddr=*(IPADDR *)template_ipv4;
#else
	fmcopy(template_ipv4,ipaddr,sizeof(IPADDR));
#endif
/*	ipaddr->type=IPADDR_IPV4;*/
/*	ipaddr->addr.ipv4.zero={0,0,0,...,0};*/
/*	ipaddr->addr.ipv4.ffff=0xffff;*/
	ipaddr->addr.ipv4.addr=ipv4addr;
	if (ipv4addr == 0) ipaddr->addr.ipv4.ffff=0;

	return ipaddr;
}


/*
IPAhX\́AIPAhX IPAhX\̂ɕϊ
@óFchar			0..
				EINET_BADFORMAT ϊs(zXgł)
@⑫Faddr=NULL Ȃ ipaddr_any ƓlԂ
*/

char inet_toipaddr(const void FAR *addr, IPADDR FAR *ipaddr)
{
	IDWORD ipv4addr;

	if (inet_toipv4addr(addr,&ipv4addr)) return EINET_BADFORMAT;
	inet_ipv4addrtoipaddr(ipv4addr,ipaddr);
	return 0;
}


/*
IPAhX\́AIPAhX IPAhXɕϊ
@óFchar			0..
				EINET_BADFORMAT ϊs
*/
char inet_tostr(const void FAR *addr, IPADDRSTR far *str)
{
	IDWORD ipv4addr;

	if (inet_toipv4addr(addr,&ipv4addr)==0) {
		char s[16];
		sprintf(s, "%d.%d.%d.%d",
			((BYTE *)(&ipv4addr))[0],
			((BYTE *)(&ipv4addr))[1],
			((BYTE *)(&ipv4addr))[2],
			((BYTE *)(&ipv4addr))[3]);
		fmcopy(s,str,16);
		return 0;
	}
	else {
		return EINET_BADFORMAT;
	}
}


/*
ChJ[hAhX
@óFchar			0..Ⴄ 0ȊO..ChJ[hAhX
@⑫Faddr=NULL, *addr="0.0.0.0", *addr=ipaddr_any ChJ[hƂ݂Ȃ
*/
char inet_iswildcard(const void FAR *addr)
{
	IDWORD ipv4addr;
	
	if (inet_toipv4addr(addr,&ipv4addr)) return 0;
	return (ipv4addr==0);
}


				
/*******************************
	eXg
*******************************/

#if defined(TEST)


#include <stdio.h>


void dispipaddr(IPADDR *ipaddr)
{
	int i;
	for (i=0; i<sizeof(IPADDR); i++) {
		printf("%02X ",((BYTE *)ipaddr)[i]);
	}
	printf("\n");
}

void main(void)
{
	char buf[80];
	int end=0;

	while(!end) {
		puts("1.(str)toipv4addr   2. (str)toipv4addr/tostr");
		gets(buf);

		switch(buf[0]) {
		case '1':{
				IDWORD ipv4addr;
				char ret;

				gets(buf);
				ret=inet_toipv4addr(buf,&ipv4addr);
				printf("ret=%x ipv4addr=%lX\n",ret,ipv4addr);
			}
			break;
		case '2':{
				IDWORD ipv4addr;
				IPADDR ipaddr;
				IPADDRSTR ipstr;
				char ret;


				gets(buf);
				ret=inet_toipv4addr(buf,&ipv4addr);
				if (ret==0) {
					inet_ipv4addrtoipaddr(ipv4addr,&ipaddr);					dispipaddr(&ipaddr);
					
					ipv4addr=0;
					ret=inet_tostr(&ipaddr,&ipstr);
					printf("ret=%x ip=%s\n",ret,ipstr);
				}
			}
			break;
		default:
			end=1;
			break;
		}
	}

}

#endif



/*
2000/ 1/16 
2000/ 1/18 
2000/ 1/22 inet_toipaddr
2000/ 1/23 inet_iswildcard
*/
