/*
 * Copyright (c) 1997,2000  XMaZ Project.
 *
 *  isoternet Protocol Library / iPv4 module / iP datagram
 *
 *  $Id$
 */

#ifndef _INET_H_ 
#define _INET_H_


#include <ttypes.h>

typedef struct {			/* IPAhX\ */
	BYTE type;			/*  <0x20 */
	BYTE reserved;			/* =0 */
	union {				/* IPAhX */
		BYTE byte[16];
		struct {
			BYTE zero[10];	/* =0 */
			WORD ffff;	/* =0xffff */
			IDWORD addr;	/* IPv4 AhX */
		} ipv4;
	} addr;
} IPADDR;

typedef char IPADDRSTR[40];		/* IPAhX */

					/* IPADDR.type */
					/* Ƌʂ邽
					   0x20 ȉł邱		*/
#define IPADDR_IPV4	0x04
/*#define IPADDR_IPV6	0x10*/

					/* G[R[h */
#define EINET_BADFORMAT	6


#if defined(_IN_ADDR2_C_)
#else
extern const IPADDR ipaddr_any;
#endif /* _IN_ADDR2_C_ */


					/* vg^Cv */
DWRD inet_aton(char *str);
char *inet_ntoa(DWRD addr);
WORD in_cksum(BYTE FAR *data, int len);
WORD inet_word(WORD w);
DWRD inet_dword(DWRD d);

char inet_toipv4addr(const void FAR *addr, IDWORD FAR *ipv4addr);
#define inet_ipaddrtoipv4addr(addr,ipv4addr) inet_toipv4addr(addr,ipv4addr)
IPADDR FAR *inet_ipv4addrtoipaddr(IDWORD ipv4addr, IPADDR FAR *ipaddr);

char inet_toipaddr(const void FAR *addr, IPADDR FAR *ipaddr);
char inet_tostr(const void FAR *addr, IPADDRSTR far *str);

char inet_iswildcard(const void FAR *addr);

uchar inet_ipv4masktobits(IDWORD ipv4addr);	/* INET.ASM */

#endif /* _INET_H_ */
