/*
 * Copyright (c) 1997	XMaZ Project.
 *
 *	isoternet Protocol Library / iPv4 Module / input routine
 *
 *	$Id: ip_input.c,v 1.1 1997/10/02 12:26:02 nakamura Exp nakamura $
 */

#include <ttypes.h>
#include <inet.h>
#include <tmem.h>
#include <log.h>
#include <ifman.h>
#include <if.h>
#include "ip.h"

extern ip_breg_type ip_breg;			/* config byte register */

#if 0
int ip_myaddrs(DWRD addr);
#endif

int ip_reass(BYTE FAR *p);

void ip_input(BYTE FAR *p, WORD len)
{
	IP FAR *h;
	WORD hlen, my_cksum, ip_cksum, ip_len;

	h = (IP FAR *) p; 
	/* length */
    ip_len = inet_word(h->ip_len);
	if (len < ip_len) {
#ifdef DEBUG
		log_printf("iP_input: Datagram is too short.ip_len-%d, data-%d", ip_len, len);
#endif
		tmem_free(p); 
		return;
	}

	/* checksum */
	hlen = (h->ip_vhl & 0x0f) << 2;
	if (ip_breg.cksum_enabled) {
		ip_cksum = h->ip_cksum;
		h->ip_cksum = 0;
		my_cksum = in_cksum((BYTE FAR *)h, hlen);
		if (ip_cksum != my_cksum) {
#ifdef DEBUG
			log_printf("iP_input: Checksum Error.");
#endif
			tmem_free(p); 
			return;
		}
	}

#ifdef DEBUG
	{
		char src[16];

		strcpy(src,inet_ntoa(h->ip_src));
		log_printf("iP_input: from %s to %s ID=%u Proto=%u Len=%u",src,inet_ntoa(h->ip_dst),inet_word(h->ip_id),h->ip_proto,inet_word(h->ip_len));
		/* log_printf("iP_input: from %s proto %d.", inet_ntoa(h->ip_src), h->ip_proto); */
		log_putbinary(p,inet_word(h->ip_len));
	}
#endif

	/* destination */
	if (ifman_myaddress(h->ip_dst)) {
		ip_reass(p);
		return;
	}
#ifdef DEBUG
	log_printf("iP_input: Destination Error.");
#endif
	tmem_free(p);
	return;
} 

int ip_reass(BYTE FAR *p)
{
	IP FAR *h;

	h = (IP FAR *) p;
	if ((h->ip_flr & 0xff3f) == 0) {
		ip_switch(p);
		return 0;
	}
#ifdef DEBUG
	log_printf("iP_input: Frangment Packet Received.\n");
#endif
	tmem_free(p);
	return 0;
}


#if 0
int ip_myaddrs(DWRD addr)
{
	if (ifs[0]->if_addr == addr) { /* i have only one network interface */
		return 1;
	}
	return 0;
}
#endif


/*
    :
1998/ 9/16
2000/ 9/23 ip_myaddrs  ifman_myaddressŒu
2000/10/ 2 ip_input Oo͒ǉ
2001/11/25 ip_input Oo͒ǉ
2001/12/ 9 SpPbgOo
*/
