/*
	Oobt@
*/

#include <dos.h>	/* FP_SEG/FP_OFF */
#include <mem.h>	/* movedata */

#include <ttypes.h>
#include "ringbuf.h"



/*
obt@
*/
void ringbuf_init(ringbuftype *b, BYTE far *buf, uint bufsize)
{
	b->buf=b->bufh=b->buft=buf;
	b->buflimit=buf+ (b->bufsize=bufsize);
}


/*
obt@̃oCg
*/
uint ringbuf_size(ringbuftype *b)
{
	return b->bufsize-1;
}


/*
obt@̋󂫃oCg
*/
uint ringbuf_left(ringbuftype *b)
{
	return (b->bufh > b->buft ) 
		/* f[^obt@I[܂Ă */
	   	? b->bufh - b->buft - 1
	   	/* f[^obt@I[܂Ȃ */
		: b->bufsize - (b->buft - b->bufh) - 1;
}


/*
obt@̎gpoCg
*/
uint ringbuf_used(ringbuftype *b)
{
	return b->bufsize - ringbuf_left(b) -1;
}


/*
obt@Ɋi[
@óFi[oCg
*/
uint ringbuf_put(ringbuftype *b, const BYTE far *data, uint len)
{
	uint a;
	
	a=ringbuf_left(b);
	if (len>a) len=a;
	if (len>0) {

		/* buft  obt@I[܂ŃRs[ */
		a= b->buflimit - b->buft;
		if (len<a) a=len;
		movedata(FP_SEG(data),FP_OFF(data)
			 ,FP_SEG(b->buft),FP_OFF(b->buft),a);

		data+=a;
		b->buft+=a;
		if (b->buft >= b->buflimit) b->buft = b->buf;

		/* obt@擪Rs[ */
		a=len-a;
		if (a>0) {
			movedata(FP_SEG(data),FP_OFF(data)
				 ,FP_SEG(b->buft),FP_OFF(b->buft),a);
			b->buft+=a;
		}

	}
	return len;
}


/*
obt@f[^oi폜ȂjiItZbgj
@óFooCg
*/
uint ringbuf_sense2(ringbuftype *b, uint offset, BYTE far *buf, uint len)
{
	uint a;
	BYTE far *p;

	a=ringbuf_used(b);
	if (offset>a) len=a=0; else a-=offset;
	if (len>a) len=a;
	if (len>0) {
		p=b->bufh;

		/* bufh  offset i߂ */
		a= b->buflimit - p;
		if (offset > a) p= b->buf + offset - a;
		else p+=offset;

		/* bufh  obt@I[܂łRs[ */
		a= b->buflimit - p;
		if (len<a) a=len;
		movedata(FP_SEG(p),FP_OFF(p),FP_SEG(buf),FP_OFF(buf),a);

		buf+=a;
		p+=a;
		if (p >= b->buflimit) p= b->buf;

		/* obt@擪Rs[ */
		a=len-a;
		if (a>0) {
			movedata(FP_SEG(p),FP_OFF(p), 
					FP_SEG(buf),FP_OFF(buf),a);
			/*p+=a;*/
		}
	}

	return len;
}



/*
obt@f[^oi폜Ȃj
@óFooCg
*/
uint ringbuf_sense(ringbuftype *b, BYTE far *buf, uint len)
{
	return ringbuf_sense2(b,0,buf,len);
}


/*
obt@f[^폜
@óF폜oCg
*/
uint ringbuf_delete(ringbuftype *b, uint len)
{
	uint a;

	a=ringbuf_used(b);
	if (len>a) len=a;

	a= b->buflimit - b->bufh;
	if (a<len) b->bufh = b->buf + len-a;
	else b->bufh += len;

	return len;
}


/*
obt@f[^o폜
@óFooCg
*/
uint ringbuf_get(ringbuftype *b, BYTE far *buf, uint len)
{
	return ringbuf_delete(b,ringbuf_sense(b,buf,len));
}



/*******************************
	eXg
*******************************/

#if defined(TEST)

#include <stdio.h>

#define BUFSIZE 32
#define WBUFSIZE 34

BYTE buf[BUFSIZE];


void main(void)
{
	ringbuftype r;
	char workbuf[WBUFSIZE];
	char endf=0;
	int a,b;

	ringbuf_init(&r,buf,BUFSIZE);

	while(!endf) {
		puts("1.size 2.left 3.used 4.put 5.sense2 6.sense 7.delete 8.get");
		scanf("%d%*c",&a);
		printf("%d:\n",a);
		
		switch(a) {
			case 1: printf("%u\n",ringbuf_size(&r)); break;
			case 2: printf("%u\n",ringbuf_left(&r)); break;
			case 3: printf("%u\n",ringbuf_used(&r)); break;
			case 4: gets(workbuf);
				printf("len: %d\n",strlen(workbuf));
				printf("%u\n",ringbuf_put(&r,workbuf,strlen(workbuf)));
				break;
			case 5: printf("offset: "); scanf("%d%*c",&a);
				printf("len: "); scanf("%d%*c",&b);
				setmem(workbuf,WBUFSIZE,'\0');
				printf("%u\n",ringbuf_sense2(&r,a,workbuf,b));
				puts(workbuf);
				break;
			case 6: printf("len: "); scanf("%d%*c",&b);
				setmem(workbuf,WBUFSIZE,'\0');
				printf("%u\n",ringbuf_sense(&r,workbuf,b));
				puts(workbuf);
				break;
			case 7: printf("len: "); scanf("%d%*c",&b);
				printf("%u\n",ringbuf_delete(&r,b));
				break;
			case 8: printf("len: "); scanf("%d%*c",&b);
				setmem(workbuf,WBUFSIZE,'\0');
				printf("%u\n",ringbuf_get(&r,workbuf,b));
				puts(workbuf);
				break;
			default: endf=1; break;
		}
	}
}



#endif

